



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Silverlight引用WebService时取消对ServiceReferences.ClientConfig文件的依赖</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Silverlight引用WebService时取消对ServiceReferences.ClientConfig文件的依赖</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 20:55:11 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>做过Silverlight项目的朋友都知道一般来说我们在Silverlight项目中都需要引用WebService或是WCF,引用的方式是在Visual Studio窗口中通过&ldquo;添加服务引用&rdquo;来添加引用，这时Visual Studio会生成一个&nbsp;ServiceReferences.ClientConfig 配置文件，这个文件中存储了WebService的地址，绑定等信息，我们在Silverlight中实例化WebService的代理类时需要用到这个文件，没有这个文件WebService代理类的实例化就会失败。</p>
<p>使用ServiceReferences.ClientConfig的方式来实例化WebService代理类比较简单，但是也有一个缺点，就是每次将Silverlight项目上线时都需要手工打开生成的XAF包，将ServiceReferences.ClientConfig文件中的WebService地址从http://Localhost/YourProject/YourWebService.asmx的形式改为http://YourDomain/YourProject/YourWebService.asmx，如果某次你忘记了修改，可能会导致你的Siverlight项目在线上无法正常运行。那么有没有一种简单的方式让我们不需要每次上线都修改ServiceReferences.ClientConfig文件，让我们摆脱对ServiceReferences.ClientConfig的信赖呢？下面就说一下我的实现方式。</p>
<p>实现原理很简单，就是在一个类里手工的构造WebService的EndPoint, Binding等信息，将ServiceReferences.ClientConfig的作用用代码来代替，示例实现代码如下，代码很简单，各位一看就明白。</p>
<div>
<pre class="prettyprint linenums">///&lt;summary&gt;<br />
/// 得到WebService对象<br />
 /// 以后实例化WebService代理时请用var serviceClient = Utility.GetDesignerServiceInstance();的形式，<br />
    ///     不要再用默认的 var serviceClient = new WSDesignerSoapClient();<br />
    /// 后一种形式会报错，因为我们删除了ServiceReferences.ClientConfig文件<br />
    ///&lt;/summary&gt;<br />
    ///&lt;returns&gt;&lt;/returns&gt;<br />
        public static WSDesignerSoapClient GetDesignerServiceInstance()<br />
        {<br />
            var basicBinding = new BasicHttpBinding() { MaxBufferSize = int.MaxValue, MaxReceivedMessageSize = int.MaxValue, Name = "WSDesignerSoap" };<br />
            basicBinding.Security.Mode = BasicHttpSecurityMode.None;<br />
            var endPoint = new EndpointAddress(getHostUrl() + "/WebService.asmx");<br />
            var ctor =<br />
                typeof (WSDesignerSoapClient).GetConstructor(new Type[] {typeof (Binding), typeof (EndpointAddress)});<br />
            return (WSDesignerSoapClient) ctor.Invoke(new object[] {basicBinding, endPoint});<br />
        }

     ///&lt;summary&gt;<br />
    /// 得到当前所在网站的根目录，如Http://localhost/flow<br />
    /// 注意站点名字必须是Flow,否则会报错。<br />
    ///&lt;/summary&gt;<br />
    ///&lt;returns&gt;&lt;/returns&gt;<br />
        private static  string getHostUrl()<br />
        {<br />
            var location = (HtmlPage.Window.GetProperty("location")) as ScriptObject;<br />
            var hrefObject = location.GetProperty("href");<br />
            string url = hrefObject.ToString().Substring(, hrefObject.ToString().IndexOf("Flow/") + );<br />
            return url;<br />
        }</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8k4n439.html">Activiti 学习笔记记录（二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rp5mm8.html">HTML5 &ndash; 3&period;加强版ol</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxvwg09.html">杂记 C中的volatile</a>
		</li>
						<li><a href="https://www.batexi.com/a/4955zke9.html">【转】一篇很全面的freemarker教程---有空慢慢实践</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydrwdgq.html">android手势事件 快速移动 长按触摸屏 按下触摸屏，并拖动</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmyjm69.html">直播视频插件--sewise player</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpp5r0q.html">centos在设置时区</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkeldj8.html">第六讲：CPU虚拟化</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkzmne8.html">怎样在一个HTML中嵌入另一个HTML页面&lpar;iframe标签用法&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/950v71m8.html">【mysql】连接查询</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zyw7j9.html">Greenplum测试部署笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpe4r69.html">centos7 ambari安装HDP</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gel3o08.html">Python&mdash;&mdash;使用Pycharm连接数据库</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjmlpz9.html">亚马逊EC2服务器申请&plus;NODE服务器部署&plus;阿里云域名申请&plus;SSL证书使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvlm2l8.html">spring boot启动报错</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwrdgj9.html">Jenkins之定时任务</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zk76yx8.html">2018中国大学生程序设计竞赛 - 网络选拔赛  Solution</a>
		</li>
						<li><a href="https://www.batexi.com/a/q15m4y29.html">js正则匹配两位小数</a>
		</li>
						<li><a href="https://www.batexi.com/a/9g33yw4q.html">&lbrack;技巧篇&rsqb;10&period;那些年我们一起优化过的MyEclipse8&period;6</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxlmn10q.html">&lbrack;原创&rsqb; Debian9上配置Samba</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8mnpn6rq.html">Eclipse快捷键 10个最有用的快捷键【转】</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwd0l4y8.html">LeetCode16 3Sum Closest</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwd0l7l8.html">C&plus;&plus; atol</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mn74eq.html">关于InputStream 和String对象之间的相互转换</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4ynm05q.html">MySQL（23）：事务的隔离级别出现问题之 脏读</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j0ppj4q.html">ArcMap 查询取位SQL</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k15vw79.html">【AR】Vuforia App key is missing&period;Please get a valid key</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ok5yyp9.html">MyEclipse设置编码方式 转载【http&colon;&sol;&sol;www&period;cnblogs&period;com&sol;susuyu&sol;archive&sol;2012&sol;06&sol;27&sol;2566062&period;html】</a>
			</li>
						<li><a href="https://www.batexi.com/a/93xn73g9.html">spring--事务原理</a>
			</li>
						<li><a href="https://www.batexi.com/a/90veyl38.html">Lnmp下安装memcached</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
